<template>
  <v-form
    v-model="valid"
    @submit.prevent="userLogin"
    ref="form"
    lazy-validation
  >
    <v-container fluid>
      <v-row>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="login.username"
            label="Username"
            outlined
            type="'email'"
            :rules="rules.username"
            placeholder="Please input user name"
            clearable
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" md="6">
          <v-text-field
            v-model="login.password"
            label="Password"
            :type="showPassword ? 'text' : 'password'"
            outlined
            clearable
          />
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <v-btn type="'submit'" color="primary" @click="doLogin"
            ><v-icon>mdi-login</v-icon>Login</v-btn
          >
        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>


<script lang="ts">
import Vue from 'vue'
import gql from 'graphql-tag'

const Login = gql(`
mutation Login($input: LoginInput!) {
  login(loginInput: $input) {
    token,
    success
  }
}
`)

export default Vue.extend({
  layout: 'plain',

  data() {
    return {
      code: '',
      item: [],
      login: {
        username: '',
        password: '',
      },
      rules: {
        username: [(v: string) => !!v || 'Name is required.'],
      },
      valid: false,
      showPassword: false,
    }
  },
  methods: {
    async onLogin() {
      try {
        const { data } = await this.$apollo.mutate({
          mutation: Login,
          variables: {
            input: {
              username: this.login.username,
              password: this.login.password,
            },
          },
        })
        this.$apolloHelpers.onLogin(data.login.token)
        console.log(data.login.token)
        this.$router.push('contacts')
      } catch (e) {}
    },
    goToSubject(): void {
      this.$router.push('contacts')
    },

    async doLogin() {
      try {
        if (this.valid) {
          let response = await this.$auth.loginWith('local', {
            data: this.login,
          })
          if (response) this.$apolloHelpers.onLogin(response.data.token)
        }
      } catch (err) {
        console.log(err)
      }
    },
  },
})

interface MyModel {
  code: string
  item: MyItem[]
  login: Login
}

interface MyItem {
  code: string
  value: number
}

interface Login {
  username: string
  password: string
}
</script>